<#ibiztemplate>
TARGET=PSSYSTEM
</#ibiztemplate>
<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <artifactId>${pub.getCodeName()?lower_case}</artifactId>
    <groupId>${pub.getPKGCodeName()?lower_case}</groupId>
    <version>${pub.getVersionString()?default("V0.0.1_alpha")}</version>
    <name>${pub.getName()}</name>
    <description></description>
    <packaging>pom</packaging>

    <parent>
        <groupId>cn.ibizlab</groupId>
        <artifactId>ibizlab-boot-starter-parent</artifactId>
        <version>2.4.0-SNAPSHOT</version>
    </parent>
    <modules>
        <!-- cores -->
        <module>${pub.getCodeName()?lower_case}-core</module>
        <!-- boot -->
        <module>${pub.getCodeName()?lower_case}-boot</module>
    </modules>

    <dependencies>
        <dependency>
             <groupId>cn.ibizlab</groupId>
             <artifactId>ibizlab-template-ibizedge</artifactId>
             <version>1.0-SNAPSHOT</version>
        </dependency>
    </dependencies>



    <repositories>

        <repository>
            <id>ibizmvnrepository</id>
            <name>ibizmvnrepository</name>
            <url>http://172.16.240.220:8081/repository/public/</url>
            <layout>default</layout>
            <releases>
                <enabled>true</enabled>
            </releases>
            <snapshots>
                <enabled>true</enabled>
                <updatePolicy>always</updatePolicy>
            </snapshots>
        </repository>
        <repository>
            <id>aliyunmaven</id>
            <name>阿里云公共仓库</name>
            <url>https://maven.aliyun.com/repository/public/</url>
            <layout>default</layout>
            <releases>
                <enabled>true</enabled>
            </releases>
            <snapshots>
                <enabled>true</enabled>
                <updatePolicy>always</updatePolicy>
            </snapshots>
        </repository>
    </repositories>


    <pluginRepositories>
        <pluginRepository>
            <id>ibizmvnrepository-plugin</id>
            <url>http://172.16.240.220:8081/repository/public/</url>
            <layout>default</layout>
            <releases>
                <enabled>true</enabled>
            </releases>
            <snapshots>
                <enabled>true</enabled>
                <updatePolicy>always</updatePolicy>
            </snapshots>
        </pluginRepository>
        <pluginRepository>
            <id>aliyun-plugin</id>
            <url>https://maven.aliyun.com/repository/public</url>
            <releases>
                <enabled>true</enabled>
            </releases>
            <snapshots>
                <enabled>false</enabled>
            </snapshots>
        </pluginRepository>
    </pluginRepositories>

    <build>
        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <configuration>
                    <source>1.8</source>
                    <target>1.8</target>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.codehaus.mojo</groupId>
                <artifactId>versions-maven-plugin</artifactId>
                <configuration>
                    <generateBackupPoms>false</generateBackupPoms>
                </configuration>
            </plugin>
			<plugin>
				<groupId>cn.ibizlab</groupId>
				<artifactId>ibizlab-generator-plugin</artifactId>
				<version>1.0-SNAPSHOT</version>
				<configuration>
					<output>
						${r'${basedir}'}/
					</output>
					<inputSpec>
						${r'${basedir}'}/${pub.modelFolder}
					</inputSpec>
					<templateDirs>
						${r'${basedir}'}/${pub.getCodeName()?lower_case}-boot/src/main/resources/templ
					</templateDirs>
					<packageName>
						${r'${project.groupId}'}
					</packageName>
					<name>
						${r'${project.artifactId}'}
					</name>
				</configuration>
                <dependencies>
                    <dependency>
                        <groupId>cn.ibizlab</groupId>
                        <artifactId>ibizlab-template-ibizedge</artifactId>
                        <version>1.0-SNAPSHOT</version>
                    </dependency>
                </dependencies>
			</plugin>
        </plugins>
    </build>

</project>
